#include <functional>
#include <iostream>
#include <numeric>
#include <array>
#include <vector>
#include <algorithm>
using namespace std;

int main(){
    int N;
    cin >> N;
    vector<array<int,4>> v(N);
    for(int i = 0; i < N; ++i)v[i][3] = i;
    for(auto &[x,y,z,k]: v) cin >> x;
    for(auto &[x,y,z,k]: v) cin >> y;
    for(auto &[x,y,z,k]: v) cin >> z;


    vector<int> dsu(N), sz(N, 0);
    iota(dsu.begin(), dsu.end(), 0);
    std::function<int(int)> find = [&](int n){
        if(dsu[n] == n)return n;
        else return dsu[n] = find(dsu[n]);
    };

    auto uni = [&](int a, int b){
        a = find(a);
        b = find(b);
        if(a == b)return;
        if(sz[a] < sz[b])swap(a,b);
        if(sz[a] == sz[b])++sz[a];
        dsu[b] = a;
    };

    bool ans = 1;

    auto check =[&](){
        sort(v.begin(), v.end());
        for(int i = 1; i < N; ++i)
            if(v[i][0] == v[i-1][0] && v[i][1] == v[i-1][1]){
                if(v[i][2] != v[i-1][2] + 1)
                    ans = 0;
                else{ 
                    uni(v[i][3], v[i-1][3]);
                }
            }
            
    };

    auto check_planes = [&](){
        iota(dsu.begin(), dsu.end(), 0);
        sz.assign(N,0);
        sort(v.begin(), v.end());
        for(int i = 1; i < N; ++i){
            if(v[i][0] == v[i-1][0] && v[i][1] == v[i-1][1] && v[i][2] == v[i-1][2] + 1)
                uni(v[i][3], v[i-1][3]);
         }
        sort(v.begin(), v.end(), [&](auto a, auto b){
            return tie(a[0], a[2], a[1]) < tie(b[0], b[2], b[1]);
        });
        for(int i = 1; i < N; ++i){
            if(v[i][0] == v[i-1][0] && v[i][2] == v[i-1][2] && v[i][1] == v[i-1][1] + 1)
                uni(v[i][3], v[i-1][3]);
        }
        for(int i = 1; i < N; ++i)
            if(v[i][0] == v[i-1][0] && find(v[i][3]) != find(v[i-1][3]))ans = 0;
    };

    check();
    for(auto &[x,y,z,k]: v)swap(y,z);
    check();
    for(auto &[x,y,z,k]: v)swap(x,z);
    check();

    for(int i = 1; i < N; ++i)if(find(i) != find(i-1))ans = 0;

    check_planes();
    for(auto &[x,y,z,k]: v)swap(x,z);
    check_planes();
    for(auto &[x,y,z,k]: v)swap(x,y);
    check_planes();


    if(ans)cout << "YES" << endl;
    else cout << "NO" << endl;
}